#!/usr/bin/env python3

class Horse:
    def __init__(self, rank, value):
        self.rank = rank
        self.value = value
    
    def getRank(self):
        return self.rank

    def getValue(self):
        return self.value
    
    def display(self):
        print(f"Horse in rank: {self.rank}, value: {self.value}")
        return

horses = {}

for i in range(100, 0, -1):
    if len(horses) == 0:
        worth = 1000
    else:
        worth = horses[i+1].getValue() + (horses[i+1].getValue() * 0.1)
    newHorse = Horse(i, round(worth, 2))
    horses[i] = newHorse

def showAll():
    for horse in reversed(list(horses.values())):
        horse.display()

menu = """-== Menu ==-
- Enter -1 to view all horses
- Enter rank to display value
- Enter q to quit.
"""

selected = input(menu)
while selected != "q":
    if selected == "-1":
        showAll()
    elif int(selected) in horses:
        horses[int(selected)].display()
    else:
        print(f"A horse with rank {selected} was not found!")
    
    selected = input(menu)