#!/usr/bin/env python3

class BankAccount:
    def __init__(self, name, email, phone) -> None:
        self.__balance = 0
        self.accountType = "Base"
        self._name = name
        self._email = email
        self._phone = phone
    
    def deposit(self, amount):
        if amount > 0:
            self.__balance += amount
            print(f"Deposited {amount} to account.")
        else:
            print("Cannot deposit a negative amount.")
        
    def withdraw(self, amount):
        if amount < 0:
            print("Cannot withdraw a negative amount.")
        else:
            if self.__balance >= amount:
                self.__balance -= amount
                print(f"Withdrawed {amount} from account.")
            else:
                print(f"You do not have enough money to withdraw {amount}")
    
    def get_balance(self):
        return f"{self.accountType} Account Balance: {self.__balance}"

class SavingsAccount(BankAccount):
    def __init__(self, name, email, phone) -> None:
        # super initializes the methods and attributes in the parent class
        super().__init__(name, email, phone)
        self.accountType = "Savings"

class CurrentAccount(BankAccount):
    def __init__(self, name, email, phone) -> None:
        super().__init__(name, email, phone)
        self.accountType = "Current"

# Test Code
ac = SavingsAccount("John Doe", "john@gmail.com", "08678622555")
ac.deposit(100)
ac.withdraw(20)
print(ac.get_balance())

print()
ac = CurrentAccount("Mary Rogers", "mary@gmail.com", "08767633322")
ac.deposit(10000)
ac.withdraw(3000)
print(ac.get_balance())
