#!/usr/bin/env python3

class Test:
    def __init__(self, subject_name, correct_answers, passing_mark):
        self.subject_name = subject_name
        self.correct_answers = correct_answers
        # have to remove % to convert to a int
        self.passing_mark = int(passing_mark.replace("%", ""))

class Student:
    def __init__(self, name):
        self.name = name
    
    # type hint here not neccessary but good for reviewing
    def take_test(self, test: Test, answers):
        correctAns = []
        for answer in answers:
            if answer in test.correct_answers:
                correctAns.append(answer)

        decimalGrade = len(correctAns) / len(test.correct_answers)
        # convert decimal grade to percent
        grade = decimalGrade * 100

        if grade <= test.passing_mark:
            print(f"{self.name} failed the {test.subject_name} test!")
        else:
            print(f"{self.name} passed the {test.subject_name} test with the score {grade}%")

paper1 = Test('Maths', ['1A', '2C', '3D', '4A', '5A'], '60%')
paper2 = Test('Chemistry', ['1C', '2C', '3D', '4A'], '75%')
paper3 = Test('Computing', ['1D', '2C', '3C', '4B', '5D', '6C', '7A'], '75%')

stu1 = Student('Tom')
stu1.take_test(paper2, ['1C', '2C', '3D', '4A'])

stu2 = Student('John')
stu2.take_test(paper1, ['1B', '2C', '3A', '4A', '5B'])
