#!/usr/bin/env python3

class Queue:
    """
    Python implementation the queue
    """

    def __init__(self):
        self.items = []

    def is_empty(self):
        return self.items == []

    def enqueue(self, item):
        self.items.insert(0, item)

    def dequeue(self):
        return self.items.pop()

    def size(self):
        return len(self.items)

    def reverse(self):
        self.items = self.items[::-1]
        return

    def reverseSome(self, k):
        reversedList = []
        for i in self.items[:k]:
            reversedList.insert(0, i)

        reversedList += self.items[k:]
        self.items = reversedList
        return

    # this is recursive bubble sort
    def sort(self, n=None):
        if not n:
            n = len(self.items)

        if n == 1:
            return

        for i in range(n-1):
            if self.items[i] > self.items[i + 1]:
                self.items[i], self.items[i + 1] = self.items[i + 1], self.items[i]

        self.sort(n - 1)




if __name__ == '__main__':
    q = Queue()
    q.enqueue(1)
    q.enqueue(2)
    q.enqueue(3)
    print(q.dequeue())
    print(q.size())
    print(q.dequeue())
    print(q.dequeue())
    print(q.is_empty())
    print(q.size())


    q.enqueue(1)
    q.enqueue(2)
    q.enqueue(3)
    q.enqueue(4)
    q.enqueue(5)
    q.enqueue(6)
    q.enqueue(7)

    print(q.items)
    q.reverse()
    print(q.items)

    q.enqueue(2)
    q.enqueue(4)
    print(q.items)
    
    # test recursive sort
    q.sort()

    print(q.items)
    
    # test reverseK elements
    q.reverseSome(3)

    print(q.items)
