# Node Class
class Node:
    def __init__(self, data) -> None:
        self.data = data
        self.next = None

# Linked list class
class LinkedList:
    def __init__(self) -> None:
        # this head attribute will be a "pointer" to the start of our linked list
        self.head = None
    
    # add new item to end of linked list
    def append(self, item):
        newNode = Node(item)
        # set head (start of list) if not already initialised
        if not self.head:
            self.head = newNode
        else:
            # else set the last item in the linked list's next param to the new node
            current = self.head
            while current.next:
                current = current.next
            current.next = newNode
    
    def __repr__(self) -> str:
        output = ""
        current = self.head
        while current.next:
            output += f"{current.data} "
            current = current.next
        # append the final node
        output += f"{current.data}"
        return output
            
lst = LinkedList()
# range here gives numbers in steps of 2 (evens) between 0 and 100
for i in range(0, 101, 2):
    lst.append(i)

print(lst)