# Node Class
class Node:
    def __init__(self, data) -> None:
        self.data = data
        self.next = None

def swap_pairs(head):
    swapped = Node(0)
    swapped.next = head

    previous = swapped

    while head and head.next:
        node1 = head
        node2 = head.next

        # preform the swap here
        node1.next = node2.next
        node2.next = node1
        previous.next = node2

        previous = node1
        head = node1.next

    # .next here to eliminate the dummy value
    return swapped.next
        
# simple print linked list function
def print_list(head):
    curr = head
    while curr.next:
        print(curr.data)
        curr = curr.next
    print(curr.data)

head = Node("1")
another_node = Node("2")
head.next = another_node
a_third_node = Node("3")
another_node.next = a_third_node
a_fourth_node = Node("4")
a_third_node.next = a_fourth_node

print_list(head)
swapped = swap_pairs(head)
print()
print_list(swapped)
