# Node Class
class Node:
    def __init__(self, data) -> None:
        self.data = data
        self.next = None

# Linked list class
class LinkedList:
    def __init__(self) -> None:
        # this head attribute will be a "pointer" to the start of our linked list
        self.head = None
    
    # add new item to end of linked list
    def append(self, item):
        newNode = Node(item)
        # set head (start of list) if not already initialised
        if not self.head:
            self.head = newNode
        else:
            # else set the last item in the linked list's next param to the new node
            current = self.head
            while current.next:
                current = current.next
            current.next = newNode
    
    def removeN(self, n):
        counter = 0
        current = self.head
        # use a counter system to keep track of when the node needs to be removed
        while current.next:
            if counter == n:
                # if this is the node to remove, the below piece of code skips onto the next
                current.next = current.next.next
            else:
                # if not just move onto the next node
                current = current.next
                # increment the counter
            counter += 1
    
    def __repr__(self) -> str:
        output = ""
        current = self.head
        while current.next:
            output += f"{current.data} "
            current = current.next
        # append the final node
        output += f"{current.data}"
        return output
            
lst = LinkedList()
for i in range(0, 6):
    lst.append(i)

print(lst)
lst.removeN(3)
print(lst)