class Stack:
    """
    Python implementation the stack
    """

    def __init__(self):
        self.items = []

    def is_empty(self):
        return self.items == []

    def push(self, item):
        self.items.append(item)

    def pop(self):
        return self.items.pop()

    def top(self):
        return self.items[len(self.items) - 1]

    def size(self):
        return len(self.items)

class TreeNode:
    def __init__(self, value) -> None:
        self.val = value
        self.left = None
        self.right = None

    def __repr__(self) -> str:
        return str(self.val)

root = TreeNode(6)

root.left = TreeNode(4)
root.left.left = TreeNode(3)
root.left.right = TreeNode(5)

root.right = TreeNode(8)
root.right.left = TreeNode(7)
root.right.right = TreeNode(9)

# iterative way
def inorder(tree):
    stack = Stack()
    current = tree

    res = []

    while not stack.is_empty() or current:

        while current:

            stack.push(current)
            current = current.left
        
        current = stack.pop()
        res.append(current)
        current = current.right

    return res

print(inorder(root))

def preorder(tree):
    stack = Stack()
    current = tree

    res = []

    while not stack.is_empty() or current:
        stack.push(current)
        current = current.right

    current = stack.pop()
    res.append(current)
    current = current.left

print(preorder(root))