class Position:
    def __init__(self, key, value, parent=None) -> None:
        self.key = key
        self.value = value
        self.parent = parent
        self.left = None
        self.right = None
    
    def __repr__(self) -> str:
        return f"{self.key} >> {self.value}"
        

class BinarySearchTree:
    def __init__(self):
        self.root = None

    def _internalUpsert(self, key, value, node, parent=None):
        if node is None:
            return Position(key, value, node)
        if key < node.key:
            node.left = self._internalUpsert(key, value, node.left, node)
        elif key > node.key:
            node.right = self._internalUpsert(key, value, node.right, node)
        elif key == node.key:
            node.value = value
        
        return node


    def upsert(self, key, value):
        if self.root is None:
            self.root = Position(key, value)
            return self.root

        return self._internalUpsert(key, value, self.root)
    
    def _internalInOrder(self, node, inOrderList):
        if not node:
            return
        self._internalInOrder(node.left, inOrderList)
        inOrderList.append(node.key)
        self._internalInOrder(node.right, inOrderList)

    def inOrder(self):
        inOrderList = []
        self._internalInOrder(self.root, inOrderList)
        return inOrderList
    
    def _internalFirst(self, node):
        # he didn't get this to work, but i think my one works right
        if node.left:
            return self._internalFirst(node.left)
        else:
            return node


    def first(self):
        # if self.root.left is None and self.root.right is None:
        #     return self.root
        return self._internalFirst(self.root)