# test driven programming
import unittest

from binarySearchTree import BinarySearchTree

class BSTTree(unittest.TestCase):
    # an upsert method is commonly used if the node doesn't exist it will insert it
    # else if it exists update it.
    def test_upsert(self):
        tree = BinarySearchTree()

        nodes = [50, 20, 60, 19, 25, 51, 62]
        for node in nodes:
            tree.upsert(node, f"{node}_value")
        
        self.assertEqual(50, tree.root.key)

        expectedInOrder = [19,20,25,50,51,60,62]
        self.assertEqual(expectedInOrder, tree.inOrder())
        self.assertEqual(19, tree.first().key)

if __name__ == "__main__":
    unittest.main()