class MySortedList:

    def __init__(self) -> None:
        self.sortedList = []

    # binary search algorithm
    def getIndex(self, key):
        # get the node that we want to index, or insert between

        low = 0; high = len(self.sortedList) - 1

        while low <= high:
            mid = (low + high) // 2
            if key == self.sortedList[mid][0]:
                return mid
            
            if key < self.sortedList[mid][0]:
                high = mid - 1
            elif key > self.sortedList[mid][0]:
                low = mid + 1
        
        return low
    
    def insert(self, key, value):
        index = self.getIndex(key)

        if index < len(self.sortedList) and self.sortedList[index][0] == key:
            # key already exists
            self.sortedList[index] = (key, value)
        else:
            # key doesn't already exist
            self.sortedList.insert(index, (key, value))
    
    def display(self):
        return "\n".join(str(s) for s in self.sortedList)

sortedMap = MySortedList()

sortedMap.insert("2024-11-04T15:10:42Z", "Transaction 1")
sortedMap.insert("2024-11-05T17:10:42Z", "Transaction 2")
sortedMap.insert("2024-11-04T18:10:42Z", "Transaction 3")
sortedMap.insert("2024-11-02T18:10:42Z", "Transaction 4")
print(sortedMap.display())
sortedMap.insert("2024-11-02T18:10:42Z", "Transaction 4 new")
print(sortedMap.display())